#ifndef _V3_H_
#define _V3_H_

#include <ostream.h>
#include <istream.h>

class V3 {

  float xyz[3];
public:
  V3() {};
  V3(float x, float y, float z);
  V3(float *xyz);
  float& operator[](int i);
  friend ostream& operator<<(ostream& ostr, V3 &v);
  friend istream& operator>>(istream& istr, V3 &v);
  V3 operator*(float scalar);
  V3 operator^(V3 op2);
  V3 operator/(float scalar);
  float operator*(V3 op1);
  V3 operator+(V3 op1);
  V3 operator-(V3 op1);
  float Length();
  V3 Normalized();
};

#endif